#include "stdafx.h"
#include "AmplifyMiPwerSC.h"
#include "dbt.h"
#include "initguid.h"


//DEFINE_GUID(GUID_DEVINTERFACE_USBXPRESS, 0x3C5E1462L, 0x5695, 0x4E18, \
//			0x87, 0x6B, 0xF3, 0xF3, 0xD0, 0x8A, 0xAF, 0x18);

//CFile mfile;
#define MAX_PACKET_SIZE_WRITE	512
#define MAX_PACKET_SIZE_READ	4096	
#define MAX_WRITE_PKTS		0x01

#define FT_READ_MSG			0x00
#define FT_WRITE_MSG		0x01
#define FT_READ_ACK			0x02
#define FT_MSG_SIZE			0x03


#define MSG_SIZE            0x07
#define NUMOFCHAN 9

AmplifierMiPowerSC::AmplifierMiPowerSC()
{

	m_firstBlock = FALSE;
	m_numBlock  =  0;



}
BOOL AmplifierMiPowerSC::OpenDevice()
{

	return TRUE;
}

BOOL AmplifierMiPowerSC::ReadData(int *data)
{
	


	return TRUE;

}
BOOL AmplifierMiPowerSC::DeviceRead(BYTE* buffer, DWORD dwSize, DWORD* lpdwBytesRead, DWORD dwTimeout)
{
	DWORD		tmpReadTO, tmpWriteTO;
	SI_STATUS	status			= SI_SUCCESS;

	// Save timeout values.
	SI_GetTimeouts(&tmpReadTO, &tmpWriteTO);

	// Set a timeout for the read
	SI_SetTimeouts(dwTimeout, 0);

	// Read the data
	status = SI_Read(m_hUSBDevice, buffer, dwSize, lpdwBytesRead);
	
	// Restore timeouts
	SI_SetTimeouts(tmpReadTO, tmpWriteTO);

	return (status == SI_SUCCESS);
}
BOOL AmplifierMiPowerSC::DeviceWrite(BYTE* buffer, DWORD dwSize, DWORD* lpdwBytesWritten, DWORD dwTimeout)
{
	DWORD		tmpReadTO, tmpWriteTO;
	SI_STATUS	status	= SI_SUCCESS;

	// Save timeout values.
	SI_GetTimeouts(&tmpReadTO, &tmpWriteTO);

	// Set a timeout for the write
	SI_SetTimeouts(0, dwTimeout);

	// Write the data
	status = SI_Write(m_hUSBDevice, buffer, dwSize, lpdwBytesWritten);

	// Restore timeouts
	SI_SetTimeouts(tmpReadTO, tmpWriteTO);

	return (status == SI_SUCCESS);
}
BOOL AmplifierMiPowerSC::Process_Imp(int *buffer ,int & parm)
{
	int Len = 2086;
	BYTE* buf = new BYTE[Len];
	DWORD		dwBytesRead	;
	
	DWORD	totalRead = 0 ;
	
	//	int Len = 1126;
	
	if (DeviceRead(buf, Len, &dwBytesRead, 3000))
	{
		//	mfile.Write(buf,dwBytesRead);
		totalRead+=dwBytesRead;
	//	cout << buf[0]<<endl;
	//	cout<<totalRead<<"    "<<dwBytesRead<<endl;
		// ÿ3ֽڡ
		// ֽڰintĸʽbС
		// ǿתIntͺ󣬻int͵ֵ
		unsigned char * b = new unsigned char [4];
		
		// жǷ񶪵
		if (!m_firstBlock)   // Ƕһ
		{
			m_firstBlock = TRUE;
			m_numBlock = buf[4];
		}else 
		{
			int temp = int(buf[4]) - m_numBlock;
			if (temp!= 1 || temp!= -255 )
			{
			//	cout << "lost data......."<< m_numBlock <<"   " << int(buf[4]) <<endl;
			}
			m_numBlock = int(buf[4]);
		}
		int j = 0 ; 
		for ( j = 0 ; j < m_blockSize ; j++)
		{
			for (int i = 0  ; i < m_chanNum-1 ; i++)
			{
				b[0] = buf[9+(j*(m_chanNum-1)*3+j*4)+3*i+2];
				b[1] = buf[9+(j*(m_chanNum-1)*3+j*4)+3*i+1];
				b[2] = buf[9+(j*(m_chanNum-1)*3+j*4)+3*i];
				if (b[2]>127)
					b[3] = 255;
				else
					b[3] = 0;
				buffer[j*m_chanNum+i] = *((int*)b);				  
			}
			buffer[j*m_chanNum+m_chanNum-1] = buf[5+(m_chanNum-1)*3*j+4*j];
			
		}	
		
		// 5 trig
			// 2 ͨ. Ox10ֵ  0X2X迹ֵ  0x30  0x40 ·ֵ

		parm = int(buf[2])-0x20;
	//	cout<<"channel:   "<<parm<<endl;
	//	cout<<"frame ID:  " << int(buf[4])<<endl;
		delete[]buf;
		delete[]b;
		return TRUE;
	}
		
	delete[]buf;
	return FALSE;

}
BOOL AmplifierMiPowerSC::Process(int *buffer )
{
	
	int Len = 2086;
	BYTE* buf = new BYTE[Len];
	DWORD		dwBytesRead	;
	
	DWORD	totalRead = 0 ;

//	int Len = 1126;

	if (DeviceRead(buf, Len, &dwBytesRead, 3000))
	{
	//	mfile.Write(buf,dwBytesRead);
		totalRead+=dwBytesRead;
		cout<<totalRead<<"    "<<dwBytesRead<<endl;
		// ÿ3ֽڡ
		// ֽڰintĸʽbС
		// ǿתIntͺ󣬻int͵ֵ
		unsigned char * b = new unsigned char [4];
		
		// жǷ񶪵
		if (!m_firstBlock)   // Ƕһ
		{
			m_firstBlock = TRUE;
			m_numBlock = buf[4];
		}else 
		{
			int temp = int(buf[4]) - m_numBlock;
			if (temp!= 1 || temp!= -255 )
			{
				cout << "lost data......."<< m_numBlock <<"   " << int(buf[4]) <<endl;
			}
			m_numBlock = int(buf[4]);
		}
		int j = 0 ; 
		for ( j = 0 ; j < m_blockSize ; j++)
		{
			for (int i = 0  ; i < m_chanNum-1 ; i++)
			{
				b[0] = buf[9+(j*(m_chanNum-1)*3+j*4)+3*i+2];
				b[1] = buf[9+(j*(m_chanNum-1)*3+j*4)+3*i+1];
				b[2] = buf[9+(j*(m_chanNum-1)*3+j*4)+3*i];
				if (b[2]>127)
					b[3] = 255;
				else
					b[3] = 0;
				buffer[j*m_chanNum+i] = *((int*)b);				  
			}
			buffer[j*m_chanNum+m_chanNum-1] = buf[5];
			// 5 trig
			// 2 ͨ. Ox10ֵ  0X2X迹ֵ  0x30  0x40 ·ֵ
			
		}
		delete[]buf;
		delete[]b;
		return TRUE;
	}

	delete[]buf;
	return FALSE;

}
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////



BOOL AmplifierMiPowerSC::Initialize(int blocksizeA,int chanNumA,int samplingRateA, int comPort,CWnd *wnd)
{

//		DEV_BROADCAST_DEVICEINTERFACE devIF = {0};

// 	devIF.dbcc_size = sizeof(devIF);    
// 	devIF.dbcc_devicetype = DBT_DEVTYP_DEVICEINTERFACE;    
// 	devIF.dbcc_classguid  = GUID_DEVINTERFACE_USBXPRESS;    
// 
// 	m_hNotifyDevNode = RegisterDeviceNotification(wnd->GetSafeHwnd(), &devIF, DEVICE_NOTIFY_WINDOW_HANDLE);

	m_hUSBDevice = INVALID_HANDLE_VALUE;



	// Get the number of USBXpress devices connected	
	SI_DEVICE_STRING	devStr;
	DWORD				dwNumDevices	= 0;
	SI_STATUS status = SI_GetNumDevices(&dwNumDevices);
	
	if (status == SI_SUCCESS)
	{
		// Go through each device and add their serial numbers to the list
		for (DWORD d = 0; d < dwNumDevices; d++)
		{
			status = SI_GetProductString(d, devStr, SI_RETURN_SERIAL_NUMBER);
			
			if (status == SI_SUCCESS)
			{
				
			}
		}
	}
	// OPEN THE device
	status = SI_Open(0, &m_hUSBDevice);		
	status=SI_SetBaudRate (m_hUSBDevice,921600);
	
	if (status == SI_SUCCESS)
	{
	}

	DWORD		dwBytesRead		= 0;
	DWORD		dwBytesWritten	= 0;
	BYTE		buf[MAX_PACKET_SIZE_READ];
	BYTE		msg[FT_MSG_SIZE];
	
	// Setup the read command buffer
	msg[0] = FT_READ_MSG;
	msg[1] = (BYTE)0xFF;
	msg[2] = (BYTE)0xFF;

	//
	// 4-6λIDNumber
    BYTE msgConnet[MSG_SIZE];
	msgConnet[0] = (BYTE)0xF0;  //֡ͷ1
	msgConnet[1] = (BYTE)0x0F;  //֡ͷ2
	msgConnet[2] = (BYTE)0x01;  //վ  ڼŴ
	msgConnet[3] = (BYTE)0x00;  //֡   01 
	msgConnet[4] = (BYTE)0x37;  //֡0
	msgConnet[5] = (BYTE)0x58;  //֡1
	msgConnet[6] = (BYTE)0x58;  //֡2
	if (DeviceWrite(msgConnet, MSG_SIZE, &dwBytesWritten, 1000))
	{
		cout << "connect "<<endl;
	}

   // ź

	BYTE msgScussed[5];
	if (DeviceRead(msgScussed, 5, &dwBytesRead, 3000))
	{

		cout <<"recieved" << msgScussed[0]<<msgScussed[1]<<msgScussed[2]<<endl;
		if (msgScussed[4] == 0x00 ) //ʧ F0 0F 01 00 00
		{
			cout<<"ʧ"<<endl;
		}

		if (msgScussed[4] == 0xFF ) //ֳɹ F0 0F 01 00 FF
		{
			cout<<"ֳɹ"<<endl;
		}
	
	}

	m_blockSize=blocksizeA;
	m_chanNum=chanNumA;
    m_samplingRate=samplingRateA;
	m_eventChanNum=1;	
	m_buffer=new int[NUMOFCHAN*m_blockSize];	
	return (status == SI_SUCCESS);
}
void AmplifierMiPowerSC::Start(int ampMode)
{
	//Ϳʼ


	// 4-6λIDNumber
    BYTE msgStart[MSG_SIZE];
	msgStart[0] = (BYTE)0xF0;
	msgStart[1] = (BYTE)0x0F;
	msgStart[2] = (BYTE)0x01;
	msgStart[3] = (BYTE)0x01;
	switch (ampMode)
	{
	case 0 :
		msgStart[4] = (BYTE)0xFF;  
		break;
	case 1:
		msgStart[4] = (BYTE)0xFE;  
		break;
	case 2:
		msgStart[4] = (BYTE)0xFD;  
		break;
	case 3:
		msgStart[4] = (BYTE)0xFC;  
		break;
		
		
	}

	// mode=0: FF ׼ 
	// mode=1: FE 迹  
	// mode=2: FD ģ 
	// mode=4: 00 ر
	unsigned long dwBytesWritten;
	if (DeviceWrite(msgStart, MSG_SIZE, &dwBytesWritten, 1000))
	{
		cout << "connect "<<endl;
	}
	
}
BOOL AmplifierMiPowerSC::Halt()
{
	// Close handle if open
	if (m_hUSBDevice != INVALID_HANDLE_VALUE)
	{
		// Close the USBXpress device
		BYTE msgStart[MSG_SIZE];
		msgStart[0] = (BYTE)0xF0;
		msgStart[1] = (BYTE)0x0F;
		msgStart[2] = (BYTE)0x01;
		msgStart[3] = (BYTE)0x01;
		msgStart[4] = (BYTE)0x00;  // FF  00  ر	
		unsigned long dwBytesWritten;
		DeviceWrite(msgStart, MSG_SIZE, &dwBytesWritten, 1000);
		
		//SI_Close(m_hUSBDevice);
		//m_hUSBDevice = INVALID_HANDLE_VALUE;
	}
	
	// Unregister for device notification
	//	UnregisterNotification();
	return TRUE;
	
}

AmplifierMiPowerSC::AmplifierMiPowerSC(int blocksizeA,int chanNumA,int samplingRateA)
{
	m_blockSize=blocksizeA;
	m_chanNum=chanNumA;
	m_samplingRate=samplingRateA;
}

AmplifierMiPowerSC::~AmplifierMiPowerSC()
{

}


int AmplifierMiPowerSC::GetChanNum()
{
	return m_chanNum;
}

int AmplifierMiPowerSC::GetBlockSize()
{
	return m_blockSize;
}

int AmplifierMiPowerSC::GetSamplingRate()
{
	return m_samplingRate;
}
