// CharInputClnDlg.cpp : implementation file
//

#include "stdafx.h"
#include "CharInputCln.h"
#include "CharInputClnDlg.h"
#include "fftw3.h"
#include "math.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About
char dict40[40]={'A','B','C','D','E','F','G','H','I','J',
                 'K','L','M','N','O','P','Q','R','S','T',
				 'U','V','W','X','Y','Z','0','1','2','3',
				 '4','5','6','7','8','9','_',',','.','?'	
			

};

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCharInputClnDlg dialog

CCharInputClnDlg::CCharInputClnDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CCharInputClnDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CCharInputClnDlg)
	m_IPAddress = _T("127.0.0.1");
	m_IPPort = 1234;
	m_strSend = _T("ID01CH001");
	m_ipadress_test = _T("127.0.0.1");
	m_ipport_test = 4000;
	m_Freq_1 = 10.0;
	m_Freq_2 = 12.0;
	m_Freq_3 = 11.0;
	m_Freq_4 = 12.5;
	m_Freq_5 = 11.5;
	m_Freq_6 = 10.5;
	m_Threshold = 0.0;
	m_ChannelNo = 1;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	m_clnSocket_TEST = NULL;
	m_clnSocket_EEG = NULL;

	m_bConnect_EEG = FALSE;
	m_bConnect_TEST = FALSE;

	m_chanNum = 17;
	m_blockSize = 40;

	m_EEGBuffer = NULL;


}

void CCharInputClnDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCharInputClnDlg)
	DDX_Control(pDX, IDC_RESULT, m_EditResult);
	DDX_Control(pDX, IDC_EDIT1, m_EditStatus);
	DDX_Text(pDX, IDC_IPADDRESS, m_IPAddress);
	DDX_Text(pDX, IDC_IPPORT, m_IPPort);
	DDX_Text(pDX, IDC_EDIT2, m_strSend);
	DDX_Text(pDX, IDC_IPADDRESS_TEST, m_ipadress_test);
	DDX_Text(pDX, IDC_IPPORT_TEST, m_ipport_test);
	DDX_Text(pDX, IDC_FREQ1, m_Freq_1);
	DDX_Text(pDX, IDC_FREQ2, m_Freq_2);
	DDX_Text(pDX, IDC_FREQ3, m_Freq_3);
	DDX_Text(pDX, IDC_FREQ4, m_Freq_4);
	DDX_Text(pDX, IDC_FREQ5, m_Freq_5);
	DDX_Text(pDX, IDC_FREQ6, m_Freq_6);
	DDX_Text(pDX, IDC_THRESHOLD, m_Threshold);
	DDX_Text(pDX, IDC_CHANNELNO, m_ChannelNo);
	DDV_MinMaxInt(pDX, m_ChannelNo, 1, 21);
	//}}AFX_DATA_MAP

}

BEGIN_MESSAGE_MAP(CCharInputClnDlg, CDialog)
	//{{AFX_MSG_MAP(CCharInputClnDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_CONNECT, OnConnect)
	ON_BN_CLICKED(IDC_SEND, OnSend)
	ON_BN_CLICKED(IDC_CONNECT_TEST, OnConnectTest)
	ON_BN_CLICKED(IDC_SETPARAM, OnSetparam)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCharInputClnDlg message handlers

BOOL CCharInputClnDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	m_chanNum = 21;
	m_blockSize = 40;
	m_bufLen = 50;		//50ݰ2000ݵ㣬2
	m_curPos = 0 ;	
	m_EEGBuffer = new int[m_chanNum*m_bufLen*m_blockSize];
	m_lbs = 0.0001276667317810304;	// Եݳm_lbs=(2.5*10^6/(49.9)^2/7864320)õuVֵ
	m_fftLen = m_blockSize*m_bufLen;
	m_fftin = (fftw_complex*) fftw_malloc(sizeof(fftw_complex)*m_fftLen);
	m_fftout= (fftw_complex*) fftw_malloc(sizeof(fftw_complex)*m_fftLen);
	m_FreqIndex = new int[6];
	m_FreqIndex[0] = (int)floor(m_Freq_1*2+0.5);
	m_FreqIndex[1] = (int)floor(m_Freq_2*2+0.5);
	m_FreqIndex[2] = (int)floor(m_Freq_3*2+0.5);
	m_FreqIndex[3] = (int)floor(m_Freq_4*2+0.5);
	m_FreqIndex[4] = (int)floor(m_Freq_5*2+0.5);
	m_FreqIndex[5] = (int)floor(m_Freq_6*2+0.5);

	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CCharInputClnDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CCharInputClnDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CCharInputClnDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}
void CCharInputClnDlg::OnReceive()
{

	int *buf = new int [m_chanNum*m_blockSize];
	int len = sizeof(int)*m_chanNum*m_blockSize;
	m_clnSocket_EEG->Receive(buf,len);
	

	int a = m_curPos*len;
	for(int i = 0 ; i< m_chanNum*m_blockSize;i++)
	{
		m_EEGBuffer[m_curPos*m_chanNum*m_blockSize+i] = buf[i];
	}
//	memcpy((char*)m_EEGBuffer+m_curPos*len,(char*)buf,len);  //ƴ
	
	m_curPos+=1;

	/************************************************************************/
	/* SSVEP BCI ʾ                                                   */
	/* fftwFFT μ: www.fftw.org								*/
	/************************************************************************/
	if (m_curPos==m_bufLen)	// m_blockSize*m_chanNum*m_bufLen = 2000, Ѵ洢2
	{
		// ָm_ChannelNoݼ
		for (i=m_ChannelNo-1;i<m_fftLen;i+=m_chanNum)
		{
			m_fftin[i][0]=m_EEGBuffer[i]*m_lbs;	// ԭʼԵתΪuVֵ
			m_fftin[i][1] = 0;
		}
		m_fftp = fftw_plan_dft_1d(m_fftLen, m_fftin, m_fftout, FFTW_FORWARD, FFTW_ESTIMATE);
		fftw_execute(m_fftp);
		
		double *fftResult = new double[6];
		for (i=0;i<6;i++)
		{
			int freqIndex = m_FreqIndex[i];
			fftResult[i] = sqrt(m_fftout[freqIndex][0]*m_fftout[freqIndex][0]
				+m_fftout[freqIndex][1]*m_fftout[freqIndex][1])/m_fftLen;
		}
		int resultIndex = 1;
		double maxResult = fftResult[0];
		for (i=1;i<6;i++)
		{
			if (fftResult[i]>maxResult)
			{
				maxResult = fftResult[i];
				resultIndex = i+1;
			}
		}
		
		if (maxResult>m_Threshold)
		{
			m_strSend.Format("ID01CH00%d",resultIndex);
			if (m_bConnect_TEST)
			{
				m_clnSocket_TEST->Send(m_strSend.GetBuffer(0),9);
				Sleep(1);
				ShowText(m_strSend);
			}			
		}
		CString showResult;
		showResult.Format("No.%d Value:%.3f",resultIndex,maxResult);
		ShowFFTResult(showResult);

		delete[]fftResult;
// 		fftw_destroy_plan(m_fftp);
// 		fftw_free(m_fftin); fftw_free(m_fftout);
	}
	/************************************************************************/
	/* SSVEP BCI CODE END                                                   */
	/************************************************************************/

	m_curPos = m_curPos%m_bufLen;
	//m_saveFile.Write(buf,len);

	delete[]buf;
}

void CCharInputClnDlg::OnConnect() 
{
	// TODO: Add your control notification handler code here

	//m_saveFile.Open("c:\\1.dat",CFile::modeWrite|CFile::modeCreate);
	if (m_bConnect_EEG)
	{
		return;
	}

	m_clnSocket_EEG=new CClientSocket;
	if(!AfxSocketInit())
	   {
		AfxMessageBox("Ŵͻ˳ʼʧ!");
		return;
	   }
	   if(!m_clnSocket_EEG->Create())
	   {
		   AfxMessageBox("Ŵͻ˴ʧ!");
		   return;
	   }
	   UpdateData(TRUE);
	   if(!m_clnSocket_EEG->Connect(m_IPAddress,m_IPPort))
	   {
		   ShowText("ӷŴʧ!");  
	   }
	   else
	   {
		   ShowText("ӷŴɹ!");
		   m_bConnect_EEG = TRUE;
	   }
	   m_clnSocket_EEG->GetDlg(this);
	   UpdateData(FALSE);
}
void CCharInputClnDlg::OnConnectTest() 
{
	// TODO: Add your control notification handler code here

	if (m_bConnect_TEST)
	{
		return;
	}
	
	m_clnSocket_TEST=new CClientSocket;
	if(!AfxSocketInit())
	   {
		AfxMessageBox("ϵͳͻ˳ʼʧ!");
		return;
	   }
	   if(!m_clnSocket_TEST->Create())
	   {
		   AfxMessageBox("ϵͳͻ˴ʧ!");
		   return;
	   }
	   UpdateData(TRUE);
	   if(!m_clnSocket_TEST->Connect(m_ipadress_test,m_ipport_test))
	   {
		   ShowText("ϵͳʧ!");
		   
	   }
	   else
	   {
		   ShowText("ϵͳɹ!");
		   m_bConnect_TEST = TRUE;
	   }
	  // m_clnSocket_EEG->GetDlg(this);
	   UpdateData(FALSE);
}

void CCharInputClnDlg::ShowText(CString tx)
{
	m_status +=tx;
	m_status += "\r\n";
	m_EditStatus.SetWindowText(m_status);
	m_EditStatus.LineScroll(m_EditStatus.GetLineCount()); 
}

void CCharInputClnDlg::ShowFFTResult(CString tx)
{
	m_FFTRestult +=tx;
	m_FFTRestult += "\r\n";
	m_EditResult.SetWindowText(m_FFTRestult);
	m_EditResult.LineScroll(m_EditResult.GetLineCount()); 
}

void CCharInputClnDlg::OnSend() 
{
	// TODO: Add your control notification handler code here

	srand((unsigned)time(0));
	UpdateData(TRUE);
	if (m_bConnect_TEST)
	{
		m_clnSocket_TEST->Send(m_strSend.GetBuffer(0),9);
		Sleep(1);
		ShowText(m_strSend);
	}
	else
	{
		AfxMessageBox("δϵͳ");
	}			
}


void CCharInputClnDlg::OnSetparam() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	m_FreqIndex[0] = (int)floor(m_Freq_1*2+0.5);
	m_FreqIndex[1] = (int)floor(m_Freq_2*2+0.5);
	m_FreqIndex[2] = (int)floor(m_Freq_3*2+0.5);
	m_FreqIndex[3] = (int)floor(m_Freq_4*2+0.5);
	m_FreqIndex[4] = (int)floor(m_Freq_5*2+0.5);
	m_FreqIndex[5] = (int)floor(m_Freq_6*2+0.5);
	m_Freq_1 = m_FreqIndex[0]/2.0;
	m_Freq_2 = m_FreqIndex[1]/2.0;
	m_Freq_3 = m_FreqIndex[2]/2.0;
	m_Freq_4 = m_FreqIndex[3]/2.0;
	m_Freq_5 = m_FreqIndex[4]/2.0;
	m_Freq_6 = m_FreqIndex[5]/2.0;
	UpdateData(FALSE);
}


BOOL CCharInputClnDlg::DestroyWindow() 
{
	// TODO: Add your specialized code here and/or call the base class
	delete[] m_FreqIndex;
	delete[] m_EEGBuffer;
	delete[] m_clnSocket_EEG;
	delete[] m_clnSocket_TEST;
	return CDialog::DestroyWindow();
}
