#ifndef AMPLIFIERMPOWER_SC_H
#define AMPLIFIERMPOWER_SC_H
#include <afx.h>
#include "../Amplify/SiUSBXp.h"




//================ķŴ===========================================================
class AmplifierMiPowerSC:public Amplifier
{
public:
	AmplifierMiPowerSC();
	AmplifierMiPowerSC(int lengthA,int chanNumA,int m_samplingRateA);

	virtual ~AmplifierMiPowerSC();

	virtual BOOL Initialize(int blocksizeA,int chanNumA,int samplingRateA,int comPort, CWnd *wnd);

	void     Start(int ampMode);
//	virtual BOOL Initialize(const ParamAmplifier &params);
	virtual BOOL Process(int *buffer);
	
    virtual	BOOL Process_Imp(int *buffer ,int & parm);



	BOOL  OpenDevice();
	BOOL  ReadData(int *data);
	BOOL  DeviceWrite(BYTE* buffer, DWORD dwSize, DWORD* lpdwBytesWritten, DWORD dwTimeout);
    BOOL  DeviceRead(BYTE* buffer, DWORD dwSize, DWORD* lpdwBytesRead, DWORD dwTimeout);
	virtual BOOL Halt();
	virtual int GetChanNum();
	virtual int GetBlockSize();
	virtual int GetSamplingRate();


protected:
    
protected:
	int m_blockSize;//ÿһĲ
	int m_chanNum;//
	int m_samplingRate;
	int m_eventChanNum;

	HANDLE m_hUSBDevice ;
	int    m_numBlock ; 
	BOOL   m_firstBlock;
//	HDEVNOTIFY m_hNotifyDevNode;

	int m_comPort;
	
	HANDLE m_hDev;

	HANDLE m_hEvent;

	HANDLE m_hCom;

	int * m_buffer;

	DWORD m_size;


	

	


//	OVERLAPPED osReader;
//	unsigned char headbuf[5];
//	unsigned char databuf[641];


//	int		cfirst,cnext;
//	bool	bfirst;


};
#endif
